/*
*   Visual Basic Callback Server Source
*
*   (c) Copyright Microsoft Corp. 1995 All Rights Reserved
*/ 

#ifndef __CallBack_H__
#define __CallBack_H__
#include "CBackODL.H"
#include "BaseDisp.H"
CLASS CCBGenerator;

CLASS CCallBack : public CBaseIDispatch
{
friend class CCBGenerator;
public:

    /* _CallBack methods */
    STDMETHOD(putref_VBHandler)(THIS_ IDispatch FAR* VBClass);
    STDMETHOD(get_CallBackType)(THIS_ VBCallBackType FAR* retVal);
	STDMETHOD(get_IsPersistent)(THIS_ VARIANT_BOOL FAR* retVal);
	CCallBack(void);
	virtual ~CCallBack(void);
	IDispatch FAR* m_pVBClass;
protected:
	VBCallBackType m_CBType;
	VARIANT_BOOL m_IsPersistent;
private:
	VARIANT_BOOL m_bContained;
	ULONG m_refs;
};
#define CB_DO_HEADER
#include "CBackDat.h"
#undef CB_DO_HEADER
#endif
