/*
*   Visual Basic Callback Server Source
*
*   (c) Copyright Microsoft Corp. 1995 All Rights Reserved
*/ 

#ifndef __CBackMap_H_Init__
#define __CBackMap_H_Init__
#pragma warning (disable: 4003)
#define Merge1(Param1, Param2, Param3) Param1##Param2##Param3
#define Merge(Param1, Param2, Param3) Merge1(Param1, Param2, Param3)
#endif

#ifndef CBField_ReturnType
	#define CBField_ReturnType void
#endif
#ifndef CBField_Help16
	#define CBField_Help16 ""
#endif
#ifndef CBField_Help32
	#define CBField_Help32 ""
#endif

#ifdef CB_DO_HEADER
	#ifdef CBPERSISTENT                                                                
		CLASS Merge(C,CBField_Name) : public CCallBack
		{
		public:
			STDMETHOD(get_ProcAddress)(THIS_ CBField_ReturnType (WINAPI FAR* FAR* retVal) (CBField_ParamList));
			STDMETHOD(put_DebugProc)(THIS_ CBField_ReturnType (WINAPI FAR* retVal) (CBField_ParamList));
			STDMETHOD(ResetCallBack)(THIS);
			Merge(C, CBField_Name)(){m_pIID =&IID_CallBack; 
			                         m_CBType = Merge(CBType_, CBField_Name); 
			                         m_IsPersistent = -1; 
			                         m_pDebugProc = NULL;}
			Merge(~C, CBField_Name)(){unsigned long iMask = 1; 
									  extern unsigned long Merge(bit, CBField_Name, InUse); 
									  Merge(bit, CBField_Name, InUse) ^= (iMask <<= m_ProcNum);}
			CBField_ReturnType (WINAPI FAR* m_pDebugProc) (CBField_ParamList);
			unsigned long m_ProcNum;
		};
	#else
		CLASS Merge(C,CBField_Name) : public CCallBack
		{
		public:
			STDMETHOD(get_ProcAddress)(THIS_ CBField_ReturnType (WINAPI FAR* FAR* retVal) (CBField_ParamList));
			STDMETHOD(put_DebugProc)(THIS_ CBField_ReturnType (WINAPI FAR* retVal) (CBField_ParamList));
			STDMETHOD(ResetCallBack)(THIS);
			Merge(C, CBField_Name)(){m_pIID =&IID_CallBack; 
									 m_CBType = Merge(CBType_, CBField_Name); 
									 m_IsPersistent = 0;}
			CBField_ReturnType (WINAPI FAR* m_pDebugProc) (CBField_ParamList);
		};
	#endif
#endif                                                                             
#ifdef CB_DO_VBHEADER                                                              
	CLASS Merge(CVB, CBField_Name) : public IDispatch
	{
	public:
	  #ifdef CBVOID
		STDMETHOD(Merge(CB_, CBField_Name)) (CBField_ParamList) = 0;
	  #else
		STDMETHOD(Merge(CB_, CBField_Name)) (CBField_ParamList, CBField_ReturnType FAR*) = 0;
	  #endif
	};
#endif                                                                             
#ifdef CB_DO_IMPLEMENT
  #ifdef CBCHECKBREAK
  	#ifdef CBVOID
  		#define DO_EXPORT1(Name, ReturnType, ParamList, CallList, Number, Index) \
  		extern "C" ReturnType WINAPI CB_##Name##Number (ParamList) \
  		{                                              \
        if (*VBInBreakMode && VBInBreakMode() ) { \
          if ( pC##Name Index ->m_pDebugProc ) \
        	  (pC##Name Index -> m_pDebugProc) (CallList);  \
          return;  \
        } \
  			if (pC##Name Index->m_pVBClass)                               \
  				((CVB##Name FAR*) (pC##Name Index->m_pVBClass))->CB_##Name (CallList); \
  			return;                                  \
  		}
  	#else
  		#define DO_EXPORT1(Name, ReturnType, ParamList, CallList, Number, Index) \
  		extern "C" ReturnType WINAPI CB_##Name##Number (ParamList) \
  		{                                              \
  			ReturnType retVal = 0;                     \
        if (*VBInBreakMode && VBInBreakMode() ) { \
          if ( pC##Name Index ->m_pDebugProc ) \
        	  return (pC##Name Index -> m_pDebugProc) (CallList);  \
          else \
            return 0;        \
        } \
  			if (pC##Name Index->m_pVBClass)                               \
  				((CVB##Name FAR*) (pC##Name Index->m_pVBClass))->CB_##Name (CallList, &retVal); \
  			return retVal;                                   \
  		}
  	#endif
  #else
  	#ifdef CBVOID
  		#define DO_EXPORT1(Name, ReturnType, ParamList, CallList, Number, Index) \
  		extern "C" ReturnType WINAPI CB_##Name##Number (ParamList) \
  		{                                              \
  			if (pC##Name Index->m_pVBClass)                               \
  				((CVB##Name FAR*) (pC##Name Index->m_pVBClass))->CB_##Name (CallList); \
  			return;                                  \
  		}
  	#else
  		#define DO_EXPORT1(Name, ReturnType, ParamList, CallList, Number, Index) \
  		extern "C" ReturnType WINAPI CB_##Name##Number (ParamList) \
  		{                                              \
  			ReturnType retVal = 0;                     \
  			if (pC##Name Index->m_pVBClass)                               \
  				((CVB##Name FAR*) (pC##Name Index->m_pVBClass))->CB_##Name (CallList, &retVal); \
  			return retVal;                                   \
  		}
  	#endif
  #endif
	#define DO_EXPORT(a,b,c,d,e,f) DO_EXPORT1(a,b,c,d,e,f)
	#ifdef CBPERSISTENT
		//IDispatch FAR* Merge(pVB, CBField_Name)[32];
		Merge(C, CBField_Name) FAR* Merge(pC, CBField_Name)[32];
		unsigned long Merge(bit, CBField_Name, InUse) = 0;
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 0, [0])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 1, [1])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 2, [2])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 3, [3])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 4, [4])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 5, [5])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 6, [6])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 7, [7])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 8, [8])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 9, [9])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 10, [10])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 11, [11])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 12, [12])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 13, [13])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 14, [14])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 15, [15])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 16, [16])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 17, [17])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 18, [18])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 19, [19])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 20, [20])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 21, [21])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 22, [22])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 23, [23])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 24, [24])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 25, [25])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 26, [26])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 27, [27])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 28, [28])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 29, [29])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 30, [30])
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, 31, [31])
		CBField_ReturnType (WINAPI FAR* Merge(CB_, CBField_Name)[]) (CBField_ParamList) = {
			Merge(CB_,CBField_Name,0), Merge(CB_,CBField_Name,1), Merge(CB_,CBField_Name,2), Merge(CB_,CBField_Name,3),
			Merge(CB_,CBField_Name,4), Merge(CB_,CBField_Name,5), Merge(CB_,CBField_Name,6), Merge(CB_,CBField_Name,7),
			Merge(CB_,CBField_Name,8), Merge(CB_,CBField_Name,9), Merge(CB_,CBField_Name,10), Merge(CB_,CBField_Name,11),
			Merge(CB_,CBField_Name,12), Merge(CB_,CBField_Name,13), Merge(CB_,CBField_Name,14), Merge(CB_,CBField_Name,15),
			Merge(CB_,CBField_Name,16), Merge(CB_,CBField_Name,17), Merge(CB_,CBField_Name,18), Merge(CB_,CBField_Name,19),
			Merge(CB_,CBField_Name,20), Merge(CB_,CBField_Name,21), Merge(CB_,CBField_Name,22), Merge(CB_,CBField_Name,23),
			Merge(CB_,CBField_Name,24), Merge(CB_,CBField_Name,25), Merge(CB_,CBField_Name,26), Merge(CB_,CBField_Name,27),
			Merge(CB_,CBField_Name,28), Merge(CB_,CBField_Name,29), Merge(CB_,CBField_Name,30), Merge(CB_,CBField_Name,31)};
		STDMETHODIMP 
		Merge(C, CBField_Name)::get_ProcAddress(THIS_ CBField_ReturnType (WINAPI FAR* FAR* retVal) (CBField_ParamList))
		{
			*retVal = Merge(CB_, CBField_Name)[m_ProcNum];
			Merge(pC, CBField_Name)[m_ProcNum] = this;
			return NOERROR;
		}
		STDMETHODIMP 
		Merge(C, CBField_Name)::put_DebugProc(THIS_ CBField_ReturnType (WINAPI FAR* NewVal) (CBField_ParamList))
		{
			m_pDebugProc = NewVal;
			return NOERROR;
		}
		STDMETHODIMP
		Merge(C, CBField_Name)::ResetCallBack(THIS)
		{
			Merge(pC, CBField_Name)[m_ProcNum] = this;
			return NOERROR;
		}
	#else 
		//IDispatch FAR* Merge(pVB, CBField_Name);
		Merge(C, CBField_Name) FAR* Merge(pC, CBField_Name);
		DO_EXPORT(CBField_Name, CBField_ReturnType, CBField_ParamList, CBField_CallList, , )
		STDMETHODIMP 
		Merge(C, CBField_Name)::get_ProcAddress(THIS_ CBField_ReturnType (WINAPI FAR* FAR* retVal) (CBField_ParamList))
		{
			*retVal = Merge(CB_, CBField_Name);
			Merge(pC, CBField_Name) = this;
			return NOERROR;
		}
		STDMETHODIMP 
		Merge(C, CBField_Name)::put_DebugProc(THIS_ CBField_ReturnType (WINAPI FAR* NewVal) (CBField_ParamList))
		{
			m_pDebugProc = NewVal;
			return NOERROR;
		}
		STDMETHODIMP
		Merge(C, CBField_Name)::ResetCallBack(THIS)
		{
			Merge(pC, CBField_Name) = this;
			return NOERROR;
		}
	#endif //CBPERSISTENT
	#undef DO_EXPORT1
	#undef DO_EXPORT
#endif                                                                             
#ifdef CB_DO_CREATE
	#ifdef CBPERSISTENT                                                                
		case Merge(CBType_, CBField_Name):
			{
			extern unsigned long Merge(bit, CBField_Name, InUse);
			unsigned long bitFreeProc = ~Merge(bit, CBField_Name, InUse);
			unsigned long iMask;
			unsigned short i;
			for (i = 0, iMask = 1; i < 32; i++, iMask <<= 1)
				{
				if (bitFreeProc & iMask)
					{
					Merge(bit, CBField_Name, InUse) |= iMask;
					if (*retVal = new Merge(C,CBField_Name))
						((Merge(C, CBField_Name) FAR*) *retVal)->m_ProcNum = i;
					break;
					}
				}
			if (32 == i)
				hr = ResultFromScode(E_FAIL);
			}
		break;
	#else
		case Merge(CBType_, CBField_Name):
			*retVal = new Merge(C, CBField_Name);
			break;
	#endif
#endif                                                                             
#ifdef CB_DO_ODL                                                                   
	#ifdef WIN32                                                                   
		[helpstring(CBField_Help32)] Merge(CBType_, CBField_Name),
	#else                                                                          
		[helpstring(CBField_Help16)] Merge(CBType_, CBField_Name),
	#endif                                                                         
#endif

#undef CBField_Name
#undef CBField_ReturnType
#undef CBField_ParamList
#undef CBField_CallList
#undef CBCHECKBREAK
#undef CBField_Help16
#undef CBField_Help32
#undef CBPERSISTENT
#undef CBVOID
