VERSION 5.00
Begin VB.Form FSearch 
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   2640
   ClientLeft      =   2760
   ClientTop       =   2400
   ClientWidth     =   6585
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2640
   ScaleWidth      =   6585
   Begin VB.CommandButton cmdReplace 
      Caption         =   "&Replace"
      Height          =   375
      Left            =   5295
      TabIndex        =   14
      Top             =   1215
      Width           =   1215
   End
   Begin VB.Frame frmMessage 
      Height          =   1200
      Left            =   255
      TabIndex        =   12
      Top             =   1155
      Width           =   1935
      Begin VB.Label lblMessage 
         Height          =   735
         Left            =   105
         TabIndex        =   13
         Top             =   315
         Width           =   1725
      End
   End
   Begin VB.CheckBox chkCase 
      Caption         =   "Match Ca&se"
      Height          =   300
      Left            =   2520
      TabIndex        =   7
      Top             =   1875
      Width           =   2400
   End
   Begin VB.CheckBox chkWord 
      Caption         =   "Find Whole Word &Only"
      Height          =   300
      Left            =   2520
      TabIndex        =   6
      Top             =   1545
      Width           =   2415
   End
   Begin VB.ComboBox cboDirection 
      Height          =   300
      ItemData        =   "SEARCH.frx":0000
      Left            =   3645
      List            =   "SEARCH.frx":000D
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1170
      Width           =   1215
   End
   Begin VB.ComboBox cboWith 
      Height          =   315
      Left            =   1665
      TabIndex        =   2
      Top             =   720
      Width           =   3375
   End
   Begin VB.ComboBox cboWhat 
      Height          =   315
      Left            =   1650
      TabIndex        =   0
      Top             =   240
      Width           =   3375
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "&Help"
      Height          =   375
      Left            =   5280
      TabIndex        =   9
      Top             =   2160
      Width           =   1215
   End
   Begin VB.CommandButton cmdAll 
      Caption         =   " Rep&lace All"
      Height          =   375
      Left            =   5280
      TabIndex        =   8
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5280
      TabIndex        =   4
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton cmdFindNext 
      Caption         =   "Find &Next"
      Default         =   -1  'True
      Height          =   375
      Left            =   5280
      TabIndex        =   3
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblDirection 
      Caption         =   "&Direction:"
      Height          =   300
      Left            =   2505
      TabIndex        =   11
      Top             =   1170
      Width           =   975
   End
   Begin VB.Label lblWith 
      Caption         =   "Replace &With: "
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   705
      Width           =   1335
   End
   Begin VB.Label lblWhat 
      Caption         =   "&Find What:"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   240
      Width           =   1455
   End
End
Attribute VB_Name = "FSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses EDITOR.CLS

''@B PublicProp
' Public properties required for any FSearch
Public ReplaceMode As Boolean
Public Editor As CEditor
''@E PublicProp

Private fSetFocus As Integer
Private iFindStart As Integer
Private fBottomFile As Boolean, fNotFirst As Boolean
Private yControl2 As Double, yControl3 As Double
Private yControl4 As Double, yControl5 As Double, yButton5 As Double

Private ordReplaceStatus As Integer
Const ordFirst = 0
Const ordLast = 1
Const ordFail = 2

Private Sub cboDirection_Change()
    Editor.SearchOptionDirection = cboDirection.ListIndex
End Sub

Private Sub chkWord_Click()
    Editor.SearchOptionWord = Not Editor.SearchOptionWord
End Sub

Private Sub Form_Load()

    DrawForm
''@B InitControl1
    ' Initialize all control values from editor
    With Editor
        chkWord.Value = -.SearchOptionWord
        chkCase.Value = -.SearchOptionCase
        cboDirection.ListIndex = -.SearchOptionDirection
''@E InitControl1
''@B InitControl2
        Dim v As Variant
        For Each v In .FindWhatList
            cboWhat.AddItem v
        Next
        cboWhat.Text = .FindWhat
        For Each v In .ReplaceWithList
            cboWith.AddItem v
        Next
        cboWith.Text = .ReplaceWith
''@E InitControl2

        Show vbModeless
    End With

End Sub

''@B chkCase_Click
Private Sub chkCase_Click()
    Editor.SearchOptionCase = Not Editor.SearchOptionCase
End Sub
''@E chkCase_Click

Private Sub cmdAll_Click()
    With Editor

        ' Save position and start search from first
        Dim iPos As Integer, s As String

        ' Find first match, but don't highlight
        iPos = .FindNext
        Do While iPos
            iPos = .ReplaceNext
        Loop

    End With
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdFindNext_Click()
    Dim i As Integer
    ' Must be something to find
    If cboWhat.Text = sEmpty Then cboWhat.SetFocus: Exit Sub
    ' When Replace user selects Next once, make it default
    cmdFindNext.Default = True
    ' Find next item
    i = Editor.FindNext
    ' Deal with failed search
    If i = 0 Then
        lblMessage.Caption = "Text not found"
    Else
        lblMessage.Caption = "Text found"
    End If
    cboWhat.SetFocus
End Sub

Private Sub cmdReplace_Click()
    With Editor

        ' Turn Find dialog into Replace dialog
        If Not ReplaceMode Then
            ReplaceMode = True
            DrawForm
            If cboWhat.Text = sEmpty Then
                cboWhat.SetFocus
            Else
                cboWith.SetFocus
            End If
            Exit Sub
        End If

        ' Must be something to replace
        If cboWhat.Text = sEmpty Then cboWhat.SetFocus: Exit Sub

        ' If you want to ask user to confirm empty replace string, do it here

        ' When user selects Replace once, make it default
        cmdReplace.Default = True

        If .ReplaceNext() Then
            Call .FindNext
        Else
            lblMessage.Caption = "Text not found"
            cboWhat.SetFocus
            Exit Sub
        End If

    End With
End Sub

Private Sub ReplaceText(sSrc As String, ByVal sReplace As String, iStart As Integer, iLen As Integer)
    sSrc = Left$(sSrc, iStart - 1) & sReplace & Mid$(sSrc, iStart + iLen)
End Sub

Private Sub cboWhat_LostFocus()
    lblMessage.Caption = sEmpty
    Editor.FindWhat = cboWhat.Text
    AddToList cboWhat, cboWhat.Text
End Sub

Private Sub cboWhat_GotFocus()
    cboWhat.SelLength = Len(cboWhat.Text)
End Sub

Private Sub cboWith_Change()
    lblMessage.Caption = Empty
End Sub

Private Sub cboWith_LostFocus()
    lblMessage.Caption = sEmpty
    Editor.ReplaceWith = cboWith.Text
    AddToList cboWith, cboWith.Text
End Sub

Private Sub cboWith_GotFocus()
    cboWith.SelLength = Len(cboWith.Text)
End Sub

Sub AddToList(lst As Control, s As String)
    If s = sEmpty Then Exit Sub

    Dim i As Integer
    For i = 0 To lst.ListCount - 1
        ' If item is in list, move to end of list
        If lst.List(i) = s Then
            lst.RemoveItem i
            lst.AddItem s
            Exit Sub
        End If
    Next
    ' If item isn't in list, add it
    lst.AddItem s
End Sub

Private Sub DrawForm()

    ''@B InitPosition
    ' Get initial button and control positions for later placement
    If fNotFirst = False Then
        fNotFirst = True
        yControl2 = cboWith.Top
        yControl3 = cboDirection.Top
        yControl4 = chkWord.Top
        yControl5 = chkCase.Top
        yButton5 = cmdHelp.Top
    End If
    ''@E InitPosition

    ''@B ReplacePosition
    ' Modify buttons and controls for current mode
    If ReplaceMode Then
        cmdCancel.Caption = "&Close"
        cmdReplace.Default = True
        cmdFindNext.Caption = "Find &Next"
        cmdReplace.Caption = "&Replace"
        Caption = "Replace"
        cmdAll.Visible = True
        lblWith.Visible = True
        cboWith.Visible = True
        cmdHelp.Top = yButton5
        frmMessage.Top = yControl3
        cboDirection.Top = yControl3
        lblDirection.Top = yControl3
        chkWord.Top = yControl4
        chkCase.Top = yControl5
    Else ' Find
    ''@E ReplacePosition...
        cmdFindNext.Caption = "&Next"
        cmdCancel.Caption = "&Close"
        cmdReplace.Caption = "&Replace..."
        Caption = "Find"
        cmdAll.Visible = False
        lblWith.Visible = False
        cboWith.Visible = False
        cmdHelp.Top = cmdAll.Top
        frmMessage.Top = yControl2
        cboDirection.Top = yControl2
        lblDirection.Top = yControl2
        chkWord.Top = yControl3
        chkCase.Top = yControl4
    End If

    ''@B NewHeight
    Dim dyTitleBar As Double, dyBtnLow As Double, dyBorder As Double
    ' Calculate height of title bar
    dyTitleBar = Height - ScaleHeight
    ' Add height of lowest element (help button moves up and down)
    dyBtnLow = cmdHelp.Top + cmdHelp.Height
    ' Add border around closest element (top button)
    dyBorder = cmdFindNext.Top
    ' Set height
    Height = dyTitleBar + dyBtnLow + dyBorder
    ''@E NewHeight

End Sub
