
#ifndef _VBUTIL_
#define _VBUTIL_

#include <windows.h> 
#include <ole2.h>
#if defined(WIN32)
#include <oleauto.h>
#else
#include <dispatch.h>
#endif
#if !defined(WIN32)
#include <toolhelp.h>
#endif
#include <commdlg.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <malloc.h>
#include <direct.h>
#include <ctype.h>
#include <errno.h>
#include <assert.h>


#if defined(WIN32)
#define DLLAPI  WINAPI 
#else
#define DLLAPI WINAPI __export
#endif

#if !defined(WIN32)		// Already defined for Win32

// typedef unsigned long       HANDLE;
typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef FLOAT               *PFLOAT;
typedef BOOL near           *PBOOL;
typedef BOOL far            *LPBOOL;
typedef BYTE near           *PBYTE;
typedef BYTE far            *LPBYTE;
typedef int near            *PINT;
typedef int far             *LPINT;
typedef WORD near           *PWORD;
typedef WORD far            *LPWORD;
typedef long far            *LPLONG;
typedef DWORD near          *PDWORD;
typedef DWORD far           *LPDWORD;
typedef void far            *LPVOID;
typedef const void far      *LPCVOID;

#endif

#define TEMP_MAX 512

#if !defined(ASSERT)
	#if defined(DEBUG)
		#define ASSERT(f) \
			if (f)        \
				NULL;     \
			else          \
				assert(f) 
	#else
		#define ASSERT(f) NULL
	#endif
#endif

#endif // _VBUTIL_
