VERSION 4.00
Begin VB.Form FInfo 
   Caption         =   "IDE Information"
   ClientHeight    =   5310
   ClientLeft      =   2925
   ClientTop       =   2640
   ClientWidth     =   9570
   Height          =   5715
   Left            =   2865
   LinkTopic       =   "Form1"
   ScaleHeight     =   5310
   ScaleWidth      =   9570
   Top             =   2295
   Width           =   9690
   Begin VB.CheckBox chkLog 
      Caption         =   "Event Logging"
      Height          =   390
      Left            =   4185
      TabIndex        =   4
      Top             =   75
      Value           =   1  'Checked
      Width           =   1530
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Default         =   -1  'True
      Height          =   495
      Left            =   7935
      TabIndex        =   3
      Top             =   105
      Width           =   1215
   End
   Begin VB.OptionButton opt 
      Caption         =   "Current Information"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Value           =   -1  'True
      Width           =   2175
   End
   Begin VB.OptionButton opt 
      Caption         =   "History Log "
      Height          =   495
      Index           =   1
      Left            =   2400
      TabIndex        =   1
      Tag             =   "optHistory"
      Top             =   -15
      Width           =   1215
   End
   Begin VB.TextBox txtOut 
      BeginProperty Font 
         name            =   "Courier New"
         charset         =   1
         weight          =   400
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   3405
      Left            =   360
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   960
      Width           =   5160
   End
End
Attribute VB_Name = "fInfo"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private rcmds As NCommands
Private rman As CAddInManager
Private rap As Application

Private Const ordInfo = 0
Private Const ordLog = 1

Public LogMode As Boolean

Public Function Create(rcmdsA As NCommands) As Boolean
    Set rcmds = rcmdsA
    Set rman = rcmds.Manager
    Set rap = rcmds.Application
    Create = True
End Function

Private Sub cmdClose_Click()
    Me.Hide
End Sub

Private Sub Form_Activate()
    ' Make sure form appears on top of IDE windows
    AppActivate Me.hWnd
End Sub

Private Sub Form_Load()
    If rcmds.LogFileName = sEmpty Then
        opt(ordInfo) = True
        opt(ordLog).Enabled = False
        opt(ordLog) = False
    Else
        opt(ordInfo) = Not LogMode
        opt(ordLog).Enabled = True
        opt(ordLog) = LogMode
    End If
    chkLog.Value = -rcmds.LogFile
    ShowIt
End Sub

Private Sub Form_Resize()
    Dim xEdge As Long, yEdge As Long
    xEdge = opt(ordInfo).Left
    yEdge = cmdClose.Top
    txtOut.Left = xEdge
    txtOut.Top = cmdClose.Height + (yEdge * 2)
    txtOut.Width = ScaleWidth - (xEdge * 2)
    txtOut.Height = ScaleHeight - cmdClose.Height - (yEdge * 3)
    cmdClose.Left = ScaleWidth - cmdClose.Width - xEdge
End Sub

Private Sub opt_Click(Index As Integer)
    LogMode = opt(ordLog)
    ShowIt
End Sub

Private Sub chkLog_Click()
    rcmds.LogFile = -chkLog.Value
    opt(ordLog).Enabled = -chkLog.Value
End Sub

Sub ShowIt()
With rcmds
    If opt(ordInfo) Then
        HourGlass Me
        txtOut.Text = GetInfo(rap)
        HourGlass Me
    Else
        Dim s As String
        s = GetFileText(.LogFileName)
        If s = sEmpty Then
            txtOut = "No log file available"
        Else
            txtOut = s
        End If
    End If
End With
End Sub

