Attribute VB_Name = "MPictureTool"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses GDITOOL.BAS FILEINFO.BAS WINTYPE.BAS

#If Win32 Then
Type TPictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long              ' hBitmap, hIcon, or hMetafile
    xExt As Long                ' hPal for bitmap
    yExt As Long
End Type
#Else
''@B TPictDesc
Type TPictDesc
    cbSizeofStruct As Integer
    picType As Integer
    hImage As Integer           ' hBitmap, hIcon, or hMetafile
    xExt As Integer             ' xExt for metafile, hPal for bitmap
    yExt As Integer             ' yExt for metafile
End Type
''@E TPictDesc
#End If

''@B TGuid
Type TGuid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type
''@E TGuid

#If Win32 Then
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" ( _
    lpPictDesc As TPictDesc, riid As TGuid, _
    ByVal fPictureOwnsHandle As Long, ipic As IPicture) As Long
#Else
''@B OleCreatePictureIndirect
Declare Function OleCreatePictureIndirect Lib "oc25.dll" ( _
    lpPictDesc As TPictDesc, riid As TGuid, _
    ByVal fPictureOwnsHandle As Integer, ipic As IPicture) As Integer
''@E OleCreatePictureIndirect
#End If

''@B IconToPicture
Function IconToPicture(hIcon) As Picture
    If hIcon = hNull Then Exit Function
    Dim pic As Picture, picdes As TPictDesc, iidIDispatch As TGuid
    ' Fill picture description
    picdes.cbSizeofStruct = Len(picdes)
    picdes.picType = vbPicTypeIcon
    picdes.hImage = hIcon
    ' Fill in magic IID number {00020400-0000-0000-C000-000000046}
    iidIDispatch.Data1 = &H20400
    iidIDispatch.Data4(0) = &HC0
    iidIDispatch.Data4(7) = &H46
    ' Create picture from icon handle, ignoring error return
    Call OleCreatePictureIndirect(picdes, iidIDispatch, True, pic)
    ' Result will be valid Picture or Nothing--either way set it
    Set IconToPicture = pic
End Function
''@E IconToPicture

#If Win32 Then
Sub GetIconSize(hIcon As Long, dx As Long, dy As Long)
    Dim ico As TIconInfo, bmp As TBitmap
    GetIconInfo hIcon, ico
    GetObjectBitmap ico.hbmMask, Len(bmp), bmp
    dx = bmp.Width
    dy = bmp.Height
End Sub
#End If
