// ERRINFO.H
//
// Standard error support class to handle project-specific errors.
//

#ifndef _ERRINFO_
#define _ERRINFO_

CLASS CSupportErrorInfo : public IUnknown
{
public:
	// IUnknown methods
	STDMETHOD(QueryInterface)(REFIID riid, void FAR * FAR * ppvObj);
    STDMETHOD_(ULONG, AddRef)(void);
	STDMETHOD_(ULONG, Release)(void);

	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	// Constructor and destructor
	CSupportErrorInfo();
	~CSupportErrorInfo();

	BSTR m_Desc;

private:

	ULONG m_refs;
	ICreateErrorInfo FAR * m_pcerrinfo;

};

#endif	// _ERRINFO_
