VERSION 4.00
Begin VB.Form FTestCollect 
   Caption         =   "Collections"
   ClientHeight    =   5040
   ClientLeft      =   1335
   ClientTop       =   1605
   ClientWidth     =   5940
   Height          =   5445
   Left            =   1275
   LinkTopic       =   "Form1"
   ScaleHeight     =   5040
   ScaleWidth      =   5940
   Top             =   1260
   Width           =   6060
   Begin VB.ListBox lstStuff 
      Height          =   1005
      Left            =   120
      TabIndex        =   10
      Top             =   3840
      Width           =   1215
   End
   Begin VB.OptionButton optSlang 
      Caption         =   "Knarly"
      Height          =   255
      Index           =   4
      Left            =   120
      TabIndex        =   9
      Top             =   3480
      Width           =   1215
   End
   Begin VB.OptionButton optSlang 
      Caption         =   "Far Out"
      Height          =   255
      Index           =   3
      Left            =   120
      TabIndex        =   8
      Top             =   3240
      Width           =   1215
   End
   Begin VB.OptionButton optSlang 
      Caption         =   "Groovy"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   7
      Top             =   3000
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.OptionButton optSlang 
      Caption         =   "Neat"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   6
      Top             =   2760
      Width           =   1215
   End
   Begin VB.OptionButton optSlang 
      Caption         =   "Cool"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   5
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1920
      Width           =   1335
   End
   Begin VB.CommandButton cmdInternal 
      Caption         =   "Internal"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton cmdStack 
      Caption         =   "Stack"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton cmdCollect 
      Caption         =   "Collection"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
   Begin VB.TextBox txtOut 
      Height          =   4695
      Left            =   1545
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   135
      Width           =   4215
   End
End
Attribute VB_Name = "FTestCollect"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private Sub cmdCollect_Click()
    Dim s As String
    ' Declare collection
    ''@B nAnimals
    Dim nAnimals As New Collection
    ''@E nAnimals
    
    s = s & "Is nAnimals a collection? " & CertifyCollection(nAnimals) & sCrLf
    Debug.Print CertifyCollection(nAnimals)

    ''@B nAnimalsAdd
    ' Create collection
    With nAnimals
        .Add "Lion"
        .Add "Tiger"
        .Add "Bear"
        .Add "Shrew", , 1
        .Add "Weasel", , , 1
    End With
    ''@E nAnimalsAdd
        
    ' Access collection items
    ''@B nAnimalsAccess
    Debug.Print nAnimals(3) & " " & nAnimals.Item(2)
    ''@E nAnimalsAccess
    
    ' Iterate through collection
    s = s & sCrLf & "Iterate with For Each: " & sCrLf
    ''@B nAnimalsForEach
    Dim vAnimal As Variant
    For Each vAnimal In nAnimals
        s = s & sTab & vAnimal & sCrLf
        Debug.Print vAnimal
    Next
    ''@E nAnimalsForEach
    
    ' Replace collection item
    s = s & "Access item 2: " & nAnimals.Item(2) & sCrLf
    ''@B nAnimalsReplace
    s = s & "Replace " & nAnimals.Item(2) & " with Wolverine" & sCrLf
    nAnimals.Remove 2
    nAnimals.Add "Wolverine", , 2
    ''@E nAnimalsReplace
        
    s = s & sCrLf & "Iterate with For I: " & sCrLf
    ''@B nAnimalsForI
    Dim i As Integer
    For i = 1 To nAnimals.Count
        s = s & sTab & nAnimals(i) & sCrLf
        Debug.Print nAnimals(i)
    Next
    ''@E nAnimalsForI
    
    s = s & "Is nAnimals still a collection? " & CertifyCollection(nAnimals) & sCrLf
    Debug.Print CertifyCollection(nAnimals)
    
    txtOut.Text = s
   
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub cmdInternal_Click()
    Dim s As String
    ''@B Forms
    s = "Forms collection:" & sCrLf
    Dim obj As Object
    For Each obj In Forms
        s = s & obj.Name & sCrLf
        Debug.Print obj.Name
    Next
    ''@E Forms
    
    s = s & sCrLf & "Controls collection:" & sCrLf
    ''@B Controls
    Dim ctl As Control
    For Each ctl In Controls
        s = s & ctl.Name & sCrLf
        Debug.Print ctl.Name
    Next
    ''@E Controls
    
    s = s & sCrLf & "Printers collection:" & sCrLf
    ''@B Printers
    Dim prt As Printer
    For Each prt In Printers
        s = s & prt.DriverName & sCrLf
        Debug.Print prt.DriverName
        ' Do something with each prt
    Next
    ''@E Printers
    
    s = s & sCrLf & "Control array:" & sCrLf
    ''@B ControlArray
    For Each ctl In optSlang
        s = s & ctl.Caption & sTab & ctl.Value & sCrLf
        Debug.Print ctl.Caption & sTab & ctl.Value
    Next
    ''@E ControlArray

    ''@B ListAdd
    lstStuff.AddItem "Lions"
    lstStuff.AddItem "Tigers"
    lstStuff.AddItem "Bears"
    ''@B ListAdd
    
    ''@B ListAccess
    Debug.Print lstStuff.List(1)
    ''@E ListAccess

    ' You can't do that!
    'For Each obj In lstStuff
    '    Debug.Print obj.Name
    'Next
    
    s = s & sCrLf & "ListBox:" & sCrLf
    ''@B ListIterate
    Dim i As Integer
    For i = 0 To lstStuff.ListCount - 1
        s = s & lstStuff.List(i) & sCrLf
        Debug.Print lstStuff.List(i)
    Next
    ''@E ListIterate
    
    txtOut.Text = s

End Sub

Private Sub cmdKey_Click()

    Dim rpc As CProblem
    Dim nProblems As New Collection
    
    Set rpc = New CProblem
    rpc.Description = "This is a test"
    rpc.Title = "Name"
    rpc.Iterations = 500
    nProblems.Add rpc, rpc.Title
    nProblems.Add rpc, rpc.Description
    'nProblems.Add rpc, rpc.Iterations
    
    Debug.Print nProblems("Name").Iterations
    
    
End Sub


Private Sub cmdStack_Click()
    Dim s As String
    s = "Push animals onto stack: " & sCrLf
    ''@B UseStack
    Dim beasts As New CStack
    With beasts
        s = s & sTab & "Push Lion" & sCrLf
        .Push "Lion"
        s = s & sTab & "Push Tiger" & sCrLf
        .Push "Tiger"
        s = s & sTab & "Push Bear" & sCrLf
        .Push "Bear"
        s = s & sTab & "Push Shrew" & sCrLf
        .Push "Shrew"
        s = s & sTab & "Push Weasel" & sCrLf
        .Push "Weasel"
        
        s = s & "Pop Animals: " & sCrLf
        Do
            s = s & sTab & "Pop " & .Pop & sCrLf
            'Debug.Print .Pop
        Loop While .Count
    End With
    ''@E UseStack
    
    s = s & "Is the beasts stack a collection? " & CertifyCollection(beasts) & sCrLf
    Debug.Print CertifyCollection(beasts)
        
    txtOut.Text = s
    
End Sub

''@B CertifyCollection
Private Function CertifyCollection(obj As Object) As Boolean
    Dim v As Variant
    With obj
        On Error Resume Next
        .Add .Count         ' Test Add and Count by adding
        v = .Item(.Count)   ' Test Item by accessing
        For Each v In obj   ' Test iteration
        Next
        .Remove .Count      ' Test Remove by removing
        CertifyCollection = (Err = 0)
    End With
End Function
''@E CertifyCollection


